Summary: The shared library for the S-Lang extension language
Name: slang
Version: 2.3.1a
Release: 1
License: GPLv2+
Group: System Environment/Libraries
Source0: http://www.jedsoft.org/releases/slang/%{name}-%{version}.tar.bz2
Source1: http://www.jedsoft.org/releases/slang/%{name}-%{version}.tar.bz2.asc
Patch0: %{name}-%{version}-aix.patch
URL: http://www.jedsoft.org/slang/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: make
BuildRequires: gcc >= 4.5.4-1
BuildRequires: libiconv >= 1.14-3
BuildRequires: libpng-devel >= 1.6.26-1
BuildRequires: oniguruma-devel >= 6.1.2-1
BuildRequires: pcre-devel >= 8.39-1
BuildRequires: readline-devel >= 7.0-2
BuildRequires: zlib-devel >= 1.2.3-7
Requires: libgcc >= 4.5.4-1

%define _libdir64 %{_prefix}/lib64

%description
S-Lang is an interpreted language and a programming library.  The
S-Lang language was designed so that it can be easily embedded into
a program to provide the program with a powerful extension language.
The S-Lang library, provided in this package, provides the S-Lang
extension language.  S-Lang's syntax resembles C, which makes it easy
to recode S-Lang procedures in C if you need to.


%package slsh
Summary: Interpreter for S-Lang scripts
Group: Development/Languages
Requires: %{name} = %{version}-%{release}
Requires: libiconv >= 1.14-3
Requires: libpng >= 1.6.26-1
Requires: oniguruma >= 6.1.2-1
Requires: pcre >= 8.39-1
Requires: readline >= 7.0-2
Requires: zlib >= 1.2.3-7

%description slsh
slsh (slang-shell) is a program for interpreting S-Lang scripts. 
It supports dynamic loading of S-Lang modules and includes a readline
interface for interactive use.

This package also includes S-Lang modules that are distributed with
the S-Lang distribution.


%package devel
Summary: Development files for the S-Lang extension language
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
This package contains files which you'll need if you want to
develop S-Lang based applications.  Documentation which may help
you write S-Lang based applications is also included.

Install the slang-devel package if you want to develop applications
based on the S-Lang extension language.


%prep
%setup -q
%patch0
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cd 32bit && tar cf - . | (cd ../64bit ; tar xpf -)


%build
export CFLAGS="-DSYSV -D_AIX -D_AIX32 -D_AIX41 -D_AIX43 -D_AIX51 -D_ALL_SOURCE -DFUNCPROTO=15 -O6 -I/opt/freeware/include"

# setup environment for 32-bit and 64-bit builds
export AR="ar -X32_64"
export NM="nm -X32_64"

cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
export CC="gcc -maix64"
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --mandir=%{_mandir} \
    --with-readline=gnu \
    --with-x \
    --with-pcre=%{_prefix} \
    --with-onig=%{_prefix} \
    --with-png=%{_prefix} \
    --with-z=%{_prefix} \
    --with-iconv=%{_prefix}
gmake %{?_smp_mflags}

cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
export CC="gcc -maix32"
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
cd ../32bit
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --with-readline=gnu \
    --with-x \
    --with-pcre=%{_prefix} \
    --with-onig=%{_prefix} \
    --with-png=%{_prefix} \
    --with-z=%{_prefix} \
    --with-iconv=%{_prefix}
gmake %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export OBJECT_MODE=64
gmake DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in * ; do
    mv -f ${f} ${f}_64
  done
)

cd ../32bit
export OBJECT_MODE=32
gmake DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

# create the proper AIX shared library
/usr/bin/ar -X32 -rv ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.a \
    ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.so.2
/usr/bin/ar -X64 -q  ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.a \
    ${RPM_BUILD_ROOT}%{_libdir64}/lib%{name}.so.2

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system)
%doc 32bit/COPYING 32bit/doc/README 32bit/changes.txt
%doc 32bit/doc/*/slang*.txt 32bit/doc/*.txt
%{_libdir}/*.a
%{_libdir}/*.so*
%{_libdir64}/*.so*
/usr/lib/*.a
/usr/lib/*.so*
/usr/lib64/*.so*


%files slsh
%defattr(-,root,system)
%doc 32bit/slsh/doc/html/slsh*.html
%config(noreplace) %{_sysconfdir}/slsh.rc
%{_bindir}/*
%{_mandir}/man1/*
%{_libdir}/%{name}
%{_libdir64}/%{name}
%{_datadir}/slsh
/usr/bin/*


%files devel
%defattr(-,root,system)
%doc 32bit/doc/*/cslang*.txt 32bit/doc/*/cref.txt
%{_includedir}/*
/usr/include/*


%changelog
* Sat Dec 10 2016 Michael Perzl <michael@perzl.org> - 2.3.1a-1
- updated to version 2.3.1a

* Sat Dec 10 2016 Michael Perzl <michael@perzl.org> - 2.3.1-1
- updated to version 2.3.1

* Thu Dec 08 2016 Michael Perzl <michael@perzl.org> - 2.3.0-1
- updated to version 2.3.0

* Tue May 15 2012 Michael Perzl <michael@perzl.org> - 2.2.4-1
- updated to version 2.2.4

* Tue May 15 2012 Michael Perzl <michael@perzl.org> - 2.2.3-1
- updated to version 2.2.3

* Tue May 15 2012 Michael Perzl <michael@perzl.org> - 2.2.2-1
- updated to version 2.2.2

* Tue May 15 2012 Michael Perzl <michael@perzl.org> - 2.2.2-1
- updated to version 2.2.2

* Tue May 15 2012 Michael Perzl <michael@perzl.org> - 2.1.4-1
- updated to version 2.1.4

* Tue Sep 09 2008 Michael Perzl <michael@perzl.org> - 2.1.3-1
- first version for AIX V5.1 and higher
